package pruefungpfingsten03;

/**
 * <p>Title: Verteilte Systeme I</p>
 * <p>Description: Prfung RMI </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: HSR</p>
 * @author J.M.Joller
 * @version 1.0
 */
import java.rmi.*;
import java.rmi.activation.*;
import java.math.*;
import java.util.*;

public class ActivatablePrimeZahl extends Activatable
       implements PrimZahlInterface {

      // Konstruktor fr Aktivierung und Export; dieser Konstruktor wird
      // von der Methode ActivationInstantiator.newInstance whrend der
      // Aktivierung aufgerufen, um das Objekt zu konstruieren.
      //

      public ActivatablePrimeZahl(ActivationID id, MarshalledObject data)
          throws RemoteException {
          // Registrieren des Objekts, welches das Aktivierungssystem
          // an einem anonymen Port anbietet (expportiert)
          //
          super(id, 0);
          System.out.println("ActivatableImplementation: Aufruf des Konstruktors");
      }

      //
      public int getPrime(int i) throws RemoteException {
        // solange i keine Primzahl ist, addiere 1
        while (!BigInteger.valueOf(i).isProbablePrime(20)) {
          System.out.println("Primzahlsuche : "+BigInteger.valueOf(i));
            i++;
        }
        // wahrscheinlich ist i jetzt Primzahl
        // (mit Wahrscheinlichkeit 1- 1/(2^20) ~= 1 zu einer Million)
        return i;
      }
  }
