package pruefungpfingsten03;

/**
 * <p>Title: Verteilte Systeme I</p>
 * <p>Description: Prfung RMI </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: HSR</p>
 * @author J.M.Joller
 * @version 1.0
 */
import java.rmi.*;
import java.rmi.activation.*;
import java.util.Properties;

public class ActivatableServer {

  // Diese Klasse registriert Informationen ber die
  //ActivatableImplementation
  // Klasse mit Hilfe von rmid und der rmiregistry
  // bentigt:
  // PrimZahlInterface
  // ActivatablePrimeZahl
  //
  // ActivatableServer
  //
  public static void main(String[] args) throws Exception {
          System.out.println("[ActivatableServer]main()");

          System.out.println("[ActivatableServer]Setzen des Security Managers");
          System.setSecurityManager(new RMISecurityManager());

          // Ab Java 2 muss eine Security Policy definiert werden
          // fr die ActivationGroup VM
          // Das erste Argument von "put" ist der Schlssel (aus der
          // Hashtabelle),
          // das zweite Argument ist dessen Wert, der Dateiname
          //
          Properties props = new Properties();
          System.out.println("[ActivatableServer]Setzen der Property 'java.security.policy'");
          props.put("java.security.policy","java.policy");

          System.out.println("[ActivatableServer]ActivationGroup");
          ActivationGroupDesc.CommandEnvironment ace = null;
          ActivationGroupDesc beispielGruppe = new ActivationGroupDesc(props, ace);

          // Registrieren der ActivationGroupDesc
          // Dies liefert eine ID
          //
          ActivationGroupID agi =
             ActivationGroup.getSystem().registerGroup(beispielGruppe);

          // kreieren der Gruppe
          //
          ActivationGroup.createGroup(agi, beispielGruppe, 0);

          // die Zeichenkette "location" spezifiziert eine URL
          // von der die Klassendefinition geladen werden kann
          // falls das Objekt aktiviert werden muss.
          // Am Schluss der URL
          // steht ein "/".
          //
          String location = "file:/C:/Joller/UnterrichtsUnterlagen/VerteilteSysteme_1/Pruefungen/PruefungPfingsten03/ActivationRepository/pruefungpfingsten03";
          System.out.println("[ActivatableServer]Lokation (URL) - "+location);

          // kreieren des Rests der Parameter
          // fr den ActivationDesc Konstruktor
          //
          MarshalledObject data = null;

          // Das zweite Argument des ActivationDesc Konstruktors wird bentigt,
          // um diese Klasse eindeutig zu identifizieren;
          // die Lokation bezieht sich relativ auf die
          // URL-formatierte Zeichenkette "location".
          //
          ActivationDesc desc = new ActivationDesc
              ("pruefungpfingsten03.ActivatablePrimeZahl", location, data);

          // Registrieren bei rmid
          //
          Remote prime = Activatable.register(desc);//
          System.out.println("[ActivatableServer]Der Stub fuer die ActivatableImplementation wurde gefunden" );

          // Binden des Stub an einen Namen in der Registry an Port 1099
          //
          Naming.rebind("RMIPrimzahl", prime);
          System.out.println("[ActivatableServer]Die ActivatableImplementation wurde exportiert" );
          System.out.println("[ActivatableServer]Ende");
          System.exit(0);
      }
  }
