package pruefungpfingsten03;

/**
 * <p>Title: Verteilte Systeme I</p>
 * <p>Description: Prfung RMI </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: HSR</p>
 * @author J.M.Joller
 * @version 1.0
 */

import java.rmi.*;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.*;


public class DynamicServer {

  // wie RMIServer


  private static final int    PORT        = 1009;
  //
  // -> passen Sie diese Zeile Ihrer Umgebung an
  //
  private static final String HOST_NAME   = "localhost";

 public static void main(String[] args) {
   System.out.println("[RMIServer]Start");
   try {
     //System.setSecurityManager(new RMISecurityManager() );

     // prfen ob die Registry gestartet wurde
     // ntigenfalls wird versucht selber eine Registry zu starten
     DieRegistry reggie = new DieRegistry(1099);

     System.out.println("[RMIServer]Kreieren eines (remote/Server-) Objekts");
     RMIPrimZahl objPrime = new RMIPrimZahl();

     // binden der Instanz an die Registry
     System.out.println("[RMIServer]binden des Objekts an die Registry");

     // zum Testen : Abfrage der Registry
     System.out.println("[RMIServer]Abfrage der Registry");
     System.out.println("[RMIServer]registrierte Objekte vor dem Binden");
     for (int i=0; i< Naming.list("rmi://localhost/").length; i++)
             System.out.println(" "+Naming.list("rmi://localhost/")[i]);

     // rebind() ist besser als bind() :
     // falls das Objekt gebunden ist, wird es einfach neu gebunden
     // falls das Objekt nicht gebunden ist, wird es gebunden (wie bind() )
     Naming.rebind("RMIPrimzahl",objPrime);
     // zum Testen : Abfrage der Registry
     System.out.println("[RMIServer]registrierte Objekte nach dem Binden");
     for (int i=0; i< Naming.list("rmi://localhost/").length; i++)
             System.out.println(" "+Naming.list("rmi://localhost/")[i]);

     System.out.println("[RMIServer]Das Objekt wurde gebunden (in die Registry eingetragen)!");
   } catch (Exception e) {
     System.err.println("[RMIServer]Eine Ausnahme wurde geworfen - "+e.getMessage() );
     e.printStackTrace();
   }
   System.out.println("[RMIServer] ... und Tschuess!");
 }



}