package pruefungpfingsten03;

/**
 * <p>Title: Verteilte Systeme I</p>
 * <p>Description: Prfung RMI </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: HSR</p>
 * @author J.M.Joller
 * @version 1.0
 */
import java.lang.reflect.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class LokalerKunde {

    public static void main(String[] args) {
      String strRoot=null,strKlasse=null,strMethode=null,strParameter=null;

      if (args.length <3) {
          System.err.println("Usage: java Main <root> <classname>"+
                             " <method> <parameter>");
      }
      /**
       Defaultwerte fr die Parameter
       strRoot : Projektverzeichnis
       strKlasse : Name der Klasse, die geladen werden soll;
       strMethode : Name der Methode der obigen Klasse, welche ausgefhrt
                    werden soll;
       strParameter : Parameter (evtl. mehrere) der obigen Methode;
       */
      strRoot = "C:/Joller/UnterrichtsUnterlagen/VerteilteSysteme_1/"+
                "Pruefungen/PruefungPfingsten03";
      strKlasse = "pruefungpfingsten03/PrimZahl";
      strMethode = "getPrime";
      strParameter = "2048";


      try {

        File file = new File(strRoot);

        /**
         * ClassLoader ist eine abstrakte Klasse
         * URLClassLoader ist eine erweitert die ClassLoader Klasse
         */
        // konvertiere File in URL
        URL url = file.toURL();          // file:/c:/.../
        URL[] urls = new URL[]{url};

        // kreiere einen neuen ClassLoader mit dem Root-Verzeichnis
        ClassLoader cl = new URLClassLoader(urls);

        // lade die gewnschte Klasse aus dem Root-Verzeichnis
        Class cls = cl.loadClass(strKlasse);

        System.out.println("[Klasse]"+cls.getName());

        Method[] methods = cls.getDeclaredMethods();
        for (int i=0; i<methods.length; i++) {
          System.out.println("[Methoden]getDeclaredMethods() : "+
                                                       methods[i]);
        }

        // getPrime() ist eine nicht-statische Methode :
        // 1) kreieren eines passenden Objekts zur geladenen Klasse
        Object objPrime = cls.newInstance();

        System.out.println("----------------------------------");
        System.out.println("Objektmethode zur Klasse: "+
                           objPrime.getClass().getName());

        // 2) festlegen des Parameter-Arrays
        Object objArgs[] = {new Integer(strParameter)};

        // 3) gezieltes Lesen der Methode aus den Metadaten
        // Parameter ist vom Typ int (also Class : Integer.TYPE)
        Class parTypes[] = {Integer.TYPE};
        Method objMethode =
            objPrime.getClass().getMethod(strMethode,parTypes);
        System.out.println("getMethod() : "+objMethode);

        // 4) Aufruf der Methode ber das Meta-Objekt
        Object objResultat = objMethode.invoke(objPrime , objArgs );
        System.out.println("Antwort von der unbekannten Klasse : "+
                           objResultat);

      } catch(java.net.MalformedURLException mue) {
        mue.printStackTrace();
      } catch(ClassNotFoundException cnfe) {
        cnfe.printStackTrace();
      } catch (java.lang.InstantiationException ie) {
        ie.printStackTrace();
      } catch(java.lang.NoSuchMethodException nsme) {
        nsme.printStackTrace();
      } catch(java.lang.reflect.InvocationTargetException ite) {
        ite.printStackTrace();
      } catch(java.lang.IllegalAccessException iae) {
        iae.printStackTrace();
      }
    }
}